;An Idea Based On Lemmings
;Coded By Stephen Ancell
;March 19 2004

Type player
Field x,y
Field w,h
Field dir
Field falling
Field anim
Field animmax
End Type

;Global gwidth=800
;Global gheight=600
Global gwidth = GfxModeWidth(CountGfxModes())
Global gheight = GfxModeHeight(CountGfxModes())
Graphics gwidth,gheight;,16,1

Global backdrop=LoadImage("lvl.png")
ResizeImage backdrop, GraphicsWidth(), GraphicsHeight()
Global x=gwidth/2,y=gheight/3

Global logo=LoadImage("eggingslogo.png")
HandleImage logo,ImageWidth(logo)/2,0

Global egg=LoadAnimImage("eggs.png",13,14,0,16)
MaskImage egg,255,0,255

Global w=8,h=16

Global animtimer=0

SetBuffer BackBuffer()

Global maintimer=CreateTimer(120)

Global timerec=0
Global animdelay=0

createplayer()

Repeat
frames=WaitTimer(maintimer)
timerec=MilliSecs()
If KeyDown(203) Then animdelay=animdelay-1
If KeyDown(205) Then animdelay=animdelay+1
If KeyHit(57) Then createplayer()
renderlevel()
renderlogo()
For f=1 To frames
playerfall()
playerbump()
playerwalk()
playeranim()
Next
renderplayer()
Flip
Until KeyHit(1)
End

Function createplayer()
For qty=1 To 1
p.player=New player
p\x=x
p\y=y
p\w=8
p\h=16
p\dir=2
p\anim=0
p\animmax=15
Next
End Function

Function renderplayer()
For p.player=Each player
DrawImage egg,p\x,p\y,p\anim
Next
End Function

Function playerwalk()
For p.player=Each player
If p\falling=False
If p\dir=1
p\x=p\x-1
EndIf
If p\dir=2
p\x=p\x+1
EndIf
EndIf
Next
End Function

Function playerbump()
LockBuffer BackBuffer()
For p.player=Each player
If p\dir=1
test=ReadPixelFast(p\x,p\y+(p\h/3)) And $ffffff
If Not test=$f8fcf8
If test Then p\dir=2
EndIf
EndIf
If p\dir=2
test=ReadPixelFast(p\x+p\w,p\y+(p\h/3)) And $ffffff
If Not test=$f8fcf8
If test Then p\dir=1
EndIf
EndIf
Next
UnlockBuffer BackBuffer()
End Function

Function playerfall()
LockBuffer BackBuffer()
For p.player=Each player
test=ReadPixelFast(p\x+(p\w/2),p\y+h) And $ffffff
If test Then p\y=p\y-1:p\falling=False
If Not test Then p\y=p\y+1:p\falling=True
Next
UnlockBuffer BackBuffer()
End Function

Function playeranim()
;If Not MilliSecs()>=timerec+animdelay Then Return
animtimer=animtimer+1
time=3
If Not animtimer>time Then Return
If animtimer>time Then animtimer=0
For p.player=Each player
If p\dir=2
p\anim=p\anim+1
If p\anim>15 Then p\anim=0
EndIf
If p\dir=1
p\anim=p\anim-1
If p\anim<0 Then p\anim=15
EndIf
Next
End Function

Function renderlevel()
DrawBlock backdrop,0-gwidth,0
End Function

Function renderlogo()
DrawBlock logo,GraphicsWidth()/2,GraphicsHeight()/2
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D